      SUBROUTINE casTMD(iset,x,kt2,mu,xpq)
      Implicit None
      Integer iset
      Double Precision  x,xbar,kt2,mu,kt
      Double Precision  XPQ(-6:7)
      Double Precision up,ubar,dn,dbar,strange,sbar,charm,cbar,bottom,bbar,top,tbar,glu,photon,z0,wplus,wminus,higgs
      Integer kf,i
      Integer IsetIni(1000),Isetcount,Nsets
      logical setfound

      Data IsetCount/0/
      Data Nsets/1/
      Data IsetIni/1000*0/
c first call initial set for setting up min and max values
      xbar=0
      kf = 0 ! kf is treated as dummy value
      setfound = .false.
      if(iset.ge.10000) then
         do i=1, Nsets
c         write(6,*) ' casTMD begin iset = Isetini(i) ',iset,Isetini(i),i,Nsets,IsetCount

         if(iset.eq.Isetini(i) ) then
            setfound = .true.
c            write(6,*) ' casTMD iset = Isetini(i) ',iset,Isetini(i),i,Nsets,IsetCount
         endif
         end do

         if(.not.setfound) then
            call TMDinit(iset)
            IsetCount = IsetCount + 1
            IsetIni(IsetCount) = iset
            Nsets = IsetCount
c            write(6,123) iset,IsetCount
123         Format(' #     casTMD initialsation: ', I8,1X,I3,'           #')
c            write(6,*) ' Descr '
c            call tmdgetdesc
c            call tmdgetextrapolation_q2

         endif
c         write(6,*) ' casTMD : ',iset,IsetIni(i),i,Nsets,IsetCount

c         Nsets = IsetCount
c 123     Continue

c first call initial set for setting up min and max values
         xbar=0
c         write(6,*) ' isel ',isel
         kt = dsqrt(kt2)
c         write(6,*) ' before calling TMDpdf '
C new call structure in TMDlib2
         call TMDset(iset)
         call TMDpdfew(x,xbar,kt,mu,up,ubar,dn,dbar,strange,sbar,charm,cbar,bottom,bbar,glu,photon, z0, wplus, wminus, higgs)

c           write(6,*)  ' kinematic ', x,kt,t
c         write(6,*)  ' casTMD: TMDpdf ',x,xbar,kt,t,up ,ubar,dn,dbar,strange,sbar,charm,cbar,bottom,bbar,glu
         xpq(0) = glu
         xpq(1) = dn
         xpq(-1) = dbar
         xpq(2) = up
         xpq(-2) = ubar
         xpq(3) = strange
         xpq(-3) = sbar
         xpq(4) = charm
         xpq(-4) = cbar
         xpq(5) = bottom
         xpq(-5) = bbar
         xpq(6) = top
         xpq(-6) = tbar
         xpq(7) = photon
c         write(6,*) 'casTMD :',xpq(7)
      else
         write(6,*) ' casTMD: Iset = ',Iset,' not implemented '
         STOP
      endif


      RETURN
      END

      Subroutine cas_getTMDlib_param
      Implicit None
      Integer iset
      Integer tmdgetorderpdf,tmdgetorderalphas
      Double Precision tmdgetlam4
      Double Precision  x,xbar,kt2,mu,kt
      Double Precision  XPQ(-6:7)
      Integer Ialps
      Double Precision mz,QCDlam,Qlam0
      Common/casalphas/mz,qcdlam,Qlam0,Ialps
      Double precision asb, asbtest

      Double Precision alpsdiff,alpsmin
      Double Precision asmz
      Common/asfit/asmz

      external asb,alpsdiff

      double precision afitmin, afitmax, afiteps, afitdelta, afitX, afitY
      Logical afitLLM
#include "casiglu.inc"
#include "casparam.inc"
      if(iglu.gt.100000) then
c         write(6,*) ' cas_getTMDlib_param ',iglu
         pi=4.d0*datan(1.d0)
         x = 0.01
         kt2 = 1.
         mu = 10.
         call casTMD(iglu,x,kt2,mu,xpq)
         write(6,*) '# TMDorder ',tmdgetorderpdf(),tmdgetorderalphas()
         Ialps = tmdgetorderpdf() +1
         IordasPS = tmdgetorderalphas() + 1

            write(6,*) '# params from TMDlib  ',Ialps,IordasPS, mz
            asmz=0.118
            if(Ialps.lt.2) asmz = 0.130
c determine qcdlam for alphas from TMDlib as alpas(mz)
            alpsmin = alpsdiff(qcdlam)
            afitmin=0.01
            afitmax=1.5
            afiteps=1.D-7
            afitdelta=10.*afiteps
            qcdlam=afitmax
c            write(6,*) ' casTMD: before fit starts '
            call dminfc(alpsdiff,afitmin,afitmax,afiteps,afitdelta,afitX,afitY,afitLLM)
            alpsmin = alpsdiff(qcdlam)
c            write(6,*) ' casTMD: alpsdiff ' , alpsmin,afitX,afitY,afitLLM
            qcdlam = afitX
            asbtest =   asb(mz)
            write(6,*) '#  casTMD: qcdlam determined: alphas = ' ,asbtest*2.*pi,qcdlam

      else
         Write(6,*) '# no TMDlib set selected ', IGLU
      endif



      Return
      End
      Function alpsdiff(x)
      Implicit none
      Double Precision asmz
      Common/asfit/asmz
      double precision alpsdiff,x,pi,alphas
      Double precision asb
      Double Precision mz,QCDlam,Qlam0
      Integer Ialps
      Common/casalphas/mz,qcdlam,Qlam0,Ialps
      external asb
      PI=4.D0*DATAN(1.D0)

      qcdlam = x
      alphas= asb(mz)*2.*pi
c      write(6,*) ' casTMD alpsdiff: alpha_s = ',alphas,qcdlam
      alpsdiff = abs(alphas - asmz)
      Return
      end